<?php
/**
 * Controller to handling get chat for admin page
 *
 * @package wp-chat-plus
 * @author InstaProduct
 * @link http://insta-product.com/
 */

if ( ! class_exists( 'IPCht_Ajax_Admin_get_chat' ))
{
  class IPCht_Ajax_Admin_get_chat
  {
  	/**
     * Execution save setting
     *
     * @return void
     */
    public function exec()
    {
    	if ( empty( $_POST['id'] ) )
      {
        echo json_encode( array(
          'status'    => 0,
          'message'   => __( 'Error', IPCHT_SLUG )
        ) );
        die();
      }
      $userId = absint( $_POST['id'] );

      $modSession = new IPCht_Model_Session();
      $modUser    = new IPCht_Model_User();
      $modChat    = new IPCht_Model_Chat();

      if ( ! $user = $modUser->getUser( $userId ))
      {
        echo json_encode( array(
          'status'    => 0,
          'message'   => __( 'Error', IPCHT_SLUG )
        ) );
        die();
      }

      if ( ! $session = $modSession->getNewSession( $user['user_id'] ))
      {
        echo json_encode( array(
          'status'    => 0,
          'message'   => __( 'Error', IPCHT_SLUG )
        ) );
        die();
      }

      //Get chats
      $chats     = '';
      $chatsData = IPCht_Chat::createBackendChats( $session );
      if ( ! empty( $chatsData['html'] )) {
        $chats = $chatsData['html'];
      }
      $lastDate = $chatsData['last_date'];

      //Check user online
      if ( IPCht_Chat::isUserOnline( $session ) ) {
        $online = 1;
      } else {
        $online = 0;
      }

      echo json_encode( array(
        'status'    => 1,
        'message'   => __( 'Success', IPCHT_SLUG ),
        'user'			=> $user,
        'session'		=> $session,
        'online'    => $online,
        'chats'			=> $chats,
        'last_date' => $lastDate
      ) );
      die();
    }
  }
}