<?php
/**
 * Controller to handling send offline message
 *
 * @package wp-chat-plus
 * @author InstaProduct
 * @link http://insta-product.com/
 */

if ( ! class_exists( 'IPCht_Ajax_Send_offline_message' ))
{
  class IPCht_Ajax_Send_offline_message
  {
    /**
     * Execution save setting
     *
     * @return void
     */
    public function exec()
    {
      global $user_ID;

      //Get system config
      $model  = new IPCht_Model_Setting();
      $system = $model->getSettings();

      //Get widget config
      $model  = new IPCht_Model_Widget();
      $widget = $model->getSettings();

      $failedMsg = stripslashes( $system->getSetting( 'failed_offline_message', __('Failed',IPCHT_SLUG) ) );
      $succesMsg = stripslashes( $system->getSetting( 'success_offline_message', __('Success',IPCHT_SLUG) ) );

      if ( empty( $_POST['email'] ) || empty( $_POST['message'] ) )
      {
        echo json_encode( array(
          'status'    => 0,
          'message'   => $failedMsg
        ) );
        die();
      }

      $result = IPCht_Chat::saveOfflineMessage();

      //
      //Send notif
      IPCht_Chat::sendNotifOfflineMsg();

      if ( $result )
      {
        echo json_encode( array(
          'status'  => 1,
          'message' => $succesMsg
        ) );
      }
      else
      {
        echo json_encode( array(
          'status'    => 0,
          'message'   => $failedMsg
        ) );
      }
      die();
    }
  }
}
