<?php
/**
 * Class helper for create admin chat page
 *
 * @package wp-chat-plus
 * @author InstaProduct
 * @link http://insta-product.com/
 */

if ( ! class_exists( 'IPCht_Admin_Dashboard' )) 
{
  class IPCht_Admin_Dashboard extends IPCht_Admin 
  {
		//{{ __construct

		/**
		 * Class construct
		 *
		 * @param array $config
		 * @return void
		 */
		public function __construct( $config = array() )
		{
			parent::__construct( $config );
		}

		//}}
		//{{ main

		/**
		 * Main content
		 *
		 * @return void
		 */
		public function main()
		{
			$this->view( 'dashboard', 'admin' );
		}

		//}}
		//{{ _setViewData

		/**
		 * Set view data
		 *
		 * @return void
		 */
		protected function _setViewData()
		{
			$this->requestID  = IPCHT_PAGENAME;
			$this->htmlRootID = 'ipcht-admin-dashboard';

			$modUser = new IPCht_Model_User();
			$this->total_users = $modUser->getTotalUsers();

			$modOffline = new IPCht_Model_ChatOffline();
			$this->total_messages = $modOffline->getTotalMessages();

			$onlines    = 0;
      $modSession = new IPCht_Model_Session();

      $users = $modSession->getUserSessions();
      if ( $users )
      {
        $_users = array();
        foreach( $users as $user )
        {
          $userId = $user->user_id;
          if ( ! array_key_exists($userId, $_users)) {
            $_users[$userId] = $user;
          }
        }

        foreach( $_users as $user )
        {
          if ( IPCht_Chat::isUserOnline( $user ) ) {
            $onlines++;
          }
        }
      }
      $this->total_onlines = $onlines;

			//Get new users
			//
			$this->new_users = $modUser->getUsers( 10 );

			//Get new messages
			//
			$this->new_messages = $modOffline->getChats( 0, array(
				'perPage' => 4
			));
		}
  }
}