<?php
if ( ! class_exists( 'IPCht_Factory' ))
{
  /**
   * Widget factory class
   *
   * @package wp-chat-plus
   * @author InstaProduct
   * @link http://insta-product.com/
   */

  class IPCht_Factory extends IPCht_Viewer
  {
    //{{ parameters

    //}}
    //{{ __construct

    /**
     * Class constructor
     *
     * @param  array $atts
     * @return void
     */
    public function __construct( $atts = array() )
    {
    }

    //}}
    //{{ render

    /**
     * Render page
     *
     * @return string
     */
    public function render()
    {
      //Get system config
      $model = new IPCht_Model_Setting();
      $this->systemConfig = $model->getSettings();

      //Get widget config
      $model = new IPCht_Model_Widget();
      $this->widgetConfig = $model->getSettings();

      //
      //Check visibility
      if ( $this->systemConfig->getSetting( 'widget_visibility', 'true' ) == 'false' )
      {
        return '';
      }

      //
      //Check restricted
      global $user_ID;
      $restricted = $this->systemConfig->getSetting( 'restricted', 'false' );
      if ( empty( $user_ID ) && $restricted == 'true' ) {
        return '';
      }

      $this->view( 'front/widget' );
    }

    //}}
    //{{ isOnline

    /**
     * Check admin is online?
     *
     * @return string
     */
    public function isOnline()
    {
      return IPCht_Chat::isOnline();
    }

    //}}
    //{{ isOffline

    /**
     * Check admin is offline?
     *
     * @return string
     */
    public function isOffline()
    {
      return IPCht_Chat::isOffline();
    }

    //}}
    //{{ isLogin

    /**
     * Check user is login?
     *
     * @return string
     */
    public function isLogin()
    {
      return IPCht_Chat::isLogin();
    }

    //}}
    
  }
}
