<?php
/**
 * Class chat model
 *
 * @package wp-chat-plus
 * @author InstaProduct
 * @link http://insta-product.com/
 */

if ( ! class_exists( 'IPCht_Model_ChatOffline' )) 
{
	/**
	 * Class for manage chat data
	 */
	class IPCht_Model_ChatOffline extends IPCht_Model
	{
		/**
		 * Get Chats
		 *
		 * @return int   $userId
		 * @return array $args
		 * @return array
		 */
		public function getChats( $userId = 0, $args = array() )
		{
			global $wpdb;
			$table  = $wpdb->prefix . 'ipcht_chat_offline';
			$query  = "
					SELECT * FROM $table
					WHERE 1=1";

			$userId = absint( $userId );
			if ( ! empty( $userId )) {
				$query .= " AND user_id = $userId";
			}
			$query .= " ORDER BY choff_timestamp DESC";

			if ( isset( $args['perPage' ] )) 
			{
				$perpage = absint( $args['perPage'] );
				$page    = 1;
				if ( isset( $args['page'] )) {
					$page = absint( $args['page'] );
				}
				$offset = ($page-1)*$perpage;
				$query .= " LIMIT $perpage OFFSET $offset"; 
			}

			$results = $wpdb->get_results( $query );
			return $results;
		}

		/**
		 * Get Chat
		 *
		 * @return int   $chatId
		 * @return array
		 */
		public function getChat( $chatId )
		{
			global $wpdb;
			$table  = $wpdb->prefix . 'ipcht_chat_offline';
			$query  = "
					SELECT * FROM $table
					WHERE
							choff_id = $chatId
			";
			$results = $wpdb->get_row( $query );
			return $results;
		}

		/**
		 * Get total messages
		 *
		 * @return array
		 */
		public function getTotalMessages()
		{
			global $wpdb;

			$table  = $wpdb->prefix . 'ipcht_chat_offline';
			$query  = "
					SELECT
						COUNT( * )
					FROM $table
			";
			$result = $wpdb->get_var( $query );
			$count  = 0;
			if ( $result ) {
				$count = $result;
			}
			return $count;
		}

		/**
		 * Insert Chat
		 *
		 * @param  array $data
		 * @param  array $format
		 * @return void
		 */
		public function insertChat( $data, $format = array() )
		{
				global $wpdb;
				$table  = $wpdb->prefix . 'ipcht_chat_offline';
				$data   = (array)$data;

				$result = $wpdb->insert( $table, $data, $format );
				if ( $result ) {
						return $wpdb->insert_id;
				}
				return false;
		}

		/**
		 * Update Chat
		 *
		 * @param  int   $id
		 * @param  array $data
		 * @return void
		 */
		public function updateChat( $id, $data )
		{
				global $wpdb;
				$table  = $wpdb->prefix . 'ipcht_chat_offline';
				$data   = (array)$data;
				$where  = array(
						'choff_id' => absint( $id )
				);
				$result = $wpdb->update( $table, $data, $where );
				return $result;
		}

		/**
		 * Delete Chat
		 *
		 * @param  int   $id
		 * @return void
		 */
		public function deleteChat( $id )
		{
			global $wpdb;
			$table  = $wpdb->prefix . 'ipcht_chat_offline';
			$where  = array(
					'choff_id' => absint( $id )
			);
			$result = $wpdb->delete( $table, $where );
			return $result;
		}

		/**
		 * Delete Chats
		 *
		 * @param  int   $userId
		 * @return void
		 */
		public function deleteChats( $userId )
		{
			global $wpdb;
			$table  = $wpdb->prefix . 'ipcht_chat_offline';
			$where  = array(
					'user_id' => absint( $userId )
			);
			$result = $wpdb->delete( $table, $where );
			return $result;
		}

	}
}